# peptide_match_open_api_20

PeptideMatchOpenApi20 - JavaScript client for peptide_match_open_api_20
This is PeptideMatch OpenAPI.
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.0.0
- Package version: 2.0.0
- Build package: io.swagger.codegen.languages.JavascriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install peptide_match_open_api_20 --save
```

##### Local development

To use the library locally without publishing to a remote npm registry, first install the dependencies by changing 
into the directory containing `package.json` (and this README). Let's call this `JAVASCRIPT_CLIENT_DIR`. Then run:

```shell
npm install
```

Next, [link](https://docs.npmjs.com/cli/link) it globally in npm with the following, also from `JAVASCRIPT_CLIENT_DIR`:

```shell
npm link
```

Finally, switch to the directory you want to use your peptide_match_open_api_20 from, and run:

```shell
npm link /path/to/<JAVASCRIPT_CLIENT_DIR>
```

You should now be able to `require('peptide_match_open_api_20')` in javascript files from the directory you ran the last 
command above from.

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/YOUR_USERNAME/peptide_match_open_api_20
then install it via:

```shell
    npm install YOUR_USERNAME/peptide_match_open_api_20 --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file, that's to say your javascript file where you actually 
use this library):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

### Webpack Configuration

Using Webpack you may encounter the following error: "Module not found: Error:
Cannot resolve module", most certainly you should disable AMD loader. Add/merge
the following section to your webpack config:

```javascript
module: {
  rules: [
    {
      parser: {
        amd: false
      }
    }
  ]
}
```

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var PeptideMatchOpenApi20 = require('peptide_match_open_api_20');

var api = new PeptideMatchOpenApi20.PeptideMatchAPI20Api()

var peptides = "AAVEEGIVLGGGCALLR,SVQYDDVPEYK"; // {String} A list of comma-separated peptide sequences (up to 100). Each sequence consists of 3 or more amino acids.

var opts = { 
  'taxonids': "9606,10090", // {String} A list fo comma-separated NCBI taxonomy IDs.
  'swissprot': true, // {Boolean} Only search SwissProt protein sequences.
  'isoform': true, // {Boolean} Include isforms.
  'uniref100': false, // {Boolean} Only search UniRef100 protein sequences.
  'leqi': false, // {Boolean} Treat Leucine (L) and Isoleucine (I) equivalent.
  'offset': 0, // {Number} Off set, page starting point, with default value 0.
  'size': 100 // {Number} Page size with default value 100. When page size is -1, it returns all records and offset will be ignored.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.matchGetGet(peptides, opts, callback);

```

## Documentation for API Endpoints

All URIs are relative to *http://research.bioinformatics.udel.edu/peptidematchapi2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*PeptideMatchOpenApi20.PeptideMatchAPI20Api* | [**matchGetGet**](docs/PeptideMatchAPI20Api.md#matchGetGet) | **GET** /match_get | Do peptide match using GET method.
*PeptideMatchOpenApi20.PeptideMatchAPI20Api* | [**matchPostPost**](docs/PeptideMatchAPI20Api.md#matchPostPost) | **POST** /match_post | Do peptide match using POST method.


## Documentation for Models

 - [PeptideMatchOpenApi20.Error](docs/Error.md)
 - [PeptideMatchOpenApi20.Protein](docs/Protein.md)
 - [PeptideMatchOpenApi20.ProteinMatchRange](docs/ProteinMatchRange.md)
 - [PeptideMatchOpenApi20.ProteinMatchingPeptide](docs/ProteinMatchingPeptide.md)
 - [PeptideMatchOpenApi20.Report](docs/Report.md)
 - [PeptideMatchOpenApi20.ReportResults](docs/ReportResults.md)
 - [PeptideMatchOpenApi20.ReportSearchParameters](docs/ReportSearchParameters.md)


## Documentation for Authorization

 All endpoints do not require authorization.

