/**
 * Peptide Match OpenAPI 2.0
 * This is PeptideMatch OpenAPI.
 *
 * OpenAPI spec version: 2.0.0
 * Contact: chenc@udel.edu
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Error', 'model/Report'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/Error'), require('../model/Report'));
  } else {
    // Browser globals (root is window)
    if (!root.PeptideMatchOpenApi20) {
      root.PeptideMatchOpenApi20 = {};
    }
    root.PeptideMatchOpenApi20.PeptideMatchAPI20Api = factory(root.PeptideMatchOpenApi20.ApiClient, root.PeptideMatchOpenApi20.Error, root.PeptideMatchOpenApi20.Report);
  }
}(this, function(ApiClient, Error, Report) {
  'use strict';

  /**
   * PeptideMatchAPI20 service.
   * @module api/PeptideMatchAPI20Api
   * @version 2.0.0
   */

  /**
   * Constructs a new PeptideMatchAPI20Api. 
   * @alias module:api/PeptideMatchAPI20Api
   * @class
   * @param {module:ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the matchGetGet operation.
     * @callback module:api/PeptideMatchAPI20Api~matchGetGetCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Report} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Do peptide match using GET method.
     * Retrieve UniProtKB protein sequences that would exactly match to the query peptides using GET method.
     * @param {String} peptides A list of comma-separated peptide sequences (up to 100). Each sequence consists of 3 or more amino acids.
     * @param {Object} opts Optional parameters
     * @param {String} opts.taxonids A list fo comma-separated NCBI taxonomy IDs. (default to 9606,10090)
     * @param {Boolean} opts.swissprot Only search SwissProt protein sequences. (default to true)
     * @param {Boolean} opts.isoform Include isforms. (default to true)
     * @param {Boolean} opts.uniref100 Only search UniRef100 protein sequences. (default to false)
     * @param {Boolean} opts.leqi Treat Leucine (L) and Isoleucine (I) equivalent. (default to false)
     * @param {Number} opts.offset Off set, page starting point, with default value 0. (default to 0)
     * @param {Number} opts.size Page size with default value 100. When page size is -1, it returns all records and offset will be ignored. (default to 100)
     * @param {module:api/PeptideMatchAPI20Api~matchGetGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Report}
     */
    this.matchGetGet = function(peptides, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'peptides' is set
      if (peptides === undefined || peptides === null) {
        throw new Error("Missing the required parameter 'peptides' when calling matchGetGet");
      }


      var pathParams = {
      };
      var queryParams = {
        'peptides': peptides,
        'taxonids': opts['taxonids'],
        'swissprot': opts['swissprot'],
        'isoform': opts['isoform'],
        'uniref100': opts['uniref100'],
        'leqi': opts['leqi'],
        'offset': opts['offset'],
        'size': opts['size']
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml', 'text/x-fasta', 'text/tab-separated-values'];
      var returnType = Report;

      return this.apiClient.callApi(
        '/match_get', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the matchPostPost operation.
     * @callback module:api/PeptideMatchAPI20Api~matchPostPostCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Report} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Do peptide match using POST method.
     * Retrieve UniProtKB protein sequences that would exactly match to the query peptides using POST method.
     * @param {String} peptides A list of comma-separated peptide sequences (up to 100). Each sequence consists of 3 or more amino acids.
     * @param {Object} opts Optional parameters
     * @param {String} opts.taxonids A list fo comma-separated NCBI taxonomy IDs. (default to 9606,10090)
     * @param {Boolean} opts.swissprot Only search SwissProt protein sequences. (default to true)
     * @param {Boolean} opts.isoform Include isoforms. (default to true)
     * @param {Boolean} opts.uniref100 Only search UniRef100 protein sequences. (default to false)
     * @param {Boolean} opts.leqi Treat Leucine (L) and Isoleucine (I) equivalent. (default to false)
     * @param {Number} opts.offset Off set, page starting point, with default value 0. (default to 0)
     * @param {Number} opts.size Page size with default value 100. When page size is -1, it returns all records and offset will be ignored. (default to 100)
     * @param {module:api/PeptideMatchAPI20Api~matchPostPostCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Report}
     */
    this.matchPostPost = function(peptides, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'peptides' is set
      if (peptides === undefined || peptides === null) {
        throw new Error("Missing the required parameter 'peptides' when calling matchPostPost");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'peptides': peptides,
        'taxonids': opts['taxonids'],
        'swissprot': opts['swissprot'],
        'isoform': opts['isoform'],
        'uniref100': opts['uniref100'],
        'leqi': opts['leqi'],
        'offset': opts['offset'],
        'size': opts['size']
      };

      var authNames = [];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = ['application/json', 'application/xml', 'text/x-fasta', 'text/tab-separated-values'];
      var returnType = Report;

      return this.apiClient.callApi(
        '/match_post', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
