/**
 * Peptide Match OpenAPI 2.0
 * This is PeptideMatch OpenAPI.
 *
 * OpenAPI spec version: 2.0.0
 * Contact: chenc@udel.edu
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ProteinMatchingPeptide'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ProteinMatchingPeptide'));
  } else {
    // Browser globals (root is window)
    if (!root.PeptideMatchOpenApi20) {
      root.PeptideMatchOpenApi20 = {};
    }
    root.PeptideMatchOpenApi20.Protein = factory(root.PeptideMatchOpenApi20.ApiClient, root.PeptideMatchOpenApi20.ProteinMatchingPeptide);
  }
}(this, function(ApiClient, ProteinMatchingPeptide) {
  'use strict';




  /**
   * The Protein model module.
   * @module model/Protein
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>Protein</code>.
   * Matched UniProt protein
   * @alias module:model/Protein
   * @class
   */
  var exports = function() {
    var _this = this;











  };

  /**
   * Constructs a <code>Protein</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Protein} obj Optional instance to populate.
   * @return {module:model/Protein} The populated <code>Protein</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('reviewStatus')) {
        obj['reviewStatus'] = ApiClient.convertToType(data['reviewStatus'], 'String');
      }
      if (data.hasOwnProperty('ac')) {
        obj['ac'] = ApiClient.convertToType(data['ac'], 'String');
      }
      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('orgName')) {
        obj['orgName'] = ApiClient.convertToType(data['orgName'], 'String');
      }
      if (data.hasOwnProperty('orgTaxonId')) {
        obj['orgTaxonId'] = ApiClient.convertToType(data['orgTaxonId'], 'Number');
      }
      if (data.hasOwnProperty('orgTaxonGroupName')) {
        obj['orgTaxonGroupName'] = ApiClient.convertToType(data['orgTaxonGroupName'], 'String');
      }
      if (data.hasOwnProperty('orgTaxonGroupId')) {
        obj['orgTaxonGroupId'] = ApiClient.convertToType(data['orgTaxonGroupId'], 'Number');
      }
      if (data.hasOwnProperty('sequence')) {
        obj['sequence'] = ApiClient.convertToType(data['sequence'], 'String');
      }
      if (data.hasOwnProperty('matchingPeptide')) {
        obj['matchingPeptide'] = ApiClient.convertToType(data['matchingPeptide'], [ProteinMatchingPeptide]);
      }
    }
    return obj;
  }

  /**
   * SwissProt or TrEMBL entry.
   * @member {String} reviewStatus
   */
  exports.prototype['reviewStatus'] = undefined;
  /**
   * Protein accession number.
   * @member {String} ac
   */
  exports.prototype['ac'] = undefined;
  /**
   * Protein ID.
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Protein name.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Organism name.
   * @member {String} orgName
   */
  exports.prototype['orgName'] = undefined;
  /**
   * Organism taxonomy ID.
   * @member {Number} orgTaxonId
   */
  exports.prototype['orgTaxonId'] = undefined;
  /**
   * Organism taxonomy group name.
   * @member {String} orgTaxonGroupName
   */
  exports.prototype['orgTaxonGroupName'] = undefined;
  /**
   * Organism taxonomy group ID.
   * @member {Number} orgTaxonGroupId
   */
  exports.prototype['orgTaxonGroupId'] = undefined;
  /**
   * Protein sequence.
   * @member {String} sequence
   */
  exports.prototype['sequence'] = undefined;
  /**
   * @member {Array.<module:model/ProteinMatchingPeptide>} matchingPeptide
   */
  exports.prototype['matchingPeptide'] = undefined;



  return exports;
}));


