/**
 * Peptide Match OpenAPI 2.0
 * This is PeptideMatch OpenAPI.
 *
 * OpenAPI spec version: 2.0.0
 * Contact: chenc@udel.edu
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.PeptideMatchOpenApi20) {
      root.PeptideMatchOpenApi20 = {};
    }
    root.PeptideMatchOpenApi20.ReportSearchParameters = factory(root.PeptideMatchOpenApi20.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The ReportSearchParameters model module.
   * @module model/ReportSearchParameters
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>ReportSearchParameters</code>.
   * @alias module:model/ReportSearchParameters
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>ReportSearchParameters</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ReportSearchParameters} obj Optional instance to populate.
   * @return {module:model/ReportSearchParameters} The populated <code>ReportSearchParameters</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('taxonids')) {
        obj['taxonids'] = ApiClient.convertToType(data['taxonids'], 'String');
      }
      if (data.hasOwnProperty('swissprot')) {
        obj['swissprot'] = ApiClient.convertToType(data['swissprot'], 'Boolean');
      }
      if (data.hasOwnProperty('isoform')) {
        obj['isoform'] = ApiClient.convertToType(data['isoform'], 'Boolean');
      }
      if (data.hasOwnProperty('uniref100')) {
        obj['uniref100'] = ApiClient.convertToType(data['uniref100'], 'Boolean');
      }
      if (data.hasOwnProperty('leqi')) {
        obj['leqi'] = ApiClient.convertToType(data['leqi'], 'Boolean');
      }
      if (data.hasOwnProperty('offset')) {
        obj['offset'] = ApiClient.convertToType(data['offset'], 'Number');
      }
      if (data.hasOwnProperty('size')) {
        obj['size'] = ApiClient.convertToType(data['size'], 'Number');
      }
    }
    return obj;
  }

  /**
   * NCBI taxonomy IDs.
   * @member {String} taxonids
   */
  exports.prototype['taxonids'] = undefined;
  /**
   * Only search SwissProt protein sequences.
   * @member {Boolean} swissprot
   */
  exports.prototype['swissprot'] = undefined;
  /**
   * Include isoforms.
   * @member {Boolean} isoform
   */
  exports.prototype['isoform'] = undefined;
  /**
   * Only search UniRef100 protein sequences.
   * @member {Boolean} uniref100
   */
  exports.prototype['uniref100'] = undefined;
  /**
   * Treat Leucine (L) and Isoleucine (I) equivalent.
   * @member {Boolean} leqi
   */
  exports.prototype['leqi'] = undefined;
  /**
   * Off set, page starting point, with default value 0.
   * @member {Number} offset
   */
  exports.prototype['offset'] = undefined;
  /**
   * Page size with default value 100. When page size is -1, it returns all records and offset will be ignored.
   * @member {Number} size
   */
  exports.prototype['size'] = undefined;



  return exports;
}));


